#include <bits/stdc++.h>

using namespace std;

typedef unordered_map<int, unordered_map<int, int>> sparse_table;

void min_table(const vector<int>& array, sparse_table& table) {
    for(int a = 0; a < array.size(); a++) table[a][a] = array[a];
    
    for(int w = 1; 2*w <= array.size(); w *= 2) {
        for(int a = 0; a + 2*w <= array.size(); a++) {
            int b = a + 2*w - 1;
            table[a][b] = min(table[a][a+w-1], table[a+w][b]);
        }
    }
    
}

int minq(sparse_table& table, int a, int b) {
    int k = log2(b - a + 1);
    assert(table.find(a) != table.end());
    assert(table[a].find(a+k-1) != table[a].end());
    assert(table.find(b-k+1) != table.end());
    assert(table[b-k+1].find(b) != table[b-k+1].end());
    return min(table[a][a+k-1], table[b-k+1][b]);
}

int main() {
    vector<int> array = {1, 3, 4, 8, 6, 1, 4, 2};
    
    sparse_table table;
    min_table(array, table);
    
#ifdef TEST
    for(auto it = table.begin(); it != table.end(); ++it) {
        auto t = it->second;
        for(auto it2 = t.begin(); it2 != t.end(); ++it2) {
            cout << it->first << " " << it2->first << " => " << it2->second << endl;
        }
    }
#endif

    cout << minq(table, 1, 6) << endl;
    
    return 0;
}

